ALTER PROCEDURE [dbo].[zone_up](@R int=1,@UniKey int=NULL OUTPUT, @ZoneFrom int=NULL, @ZoneTo int=NULL, 
@Price money=NULL,				--
@CurrentUserUniKey int=null,	-- 
@lat float=0,					--
@lon float=0,					--
@radius float=0,				--
@AddSum money=0,				--.   
@KmBetweenZone float=null,
@MinBetweenZone int=0,
@isSaveJournal bit=1, 
@DateChange datetime=null,
@PolygonColor int=null,
@OrderSrcWEB int=null,
@isShowAsParking bit=1,
@isWEBAvailable	bit=1,			--      WEB 
@NameGeoRegion varchar(64)=NULL,
@Comment varchar(128)=null,
@ZoneName varchar(256)=NULL,	
@SelectOrder varchar(512)=null OUTPUT)  AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <17/02/2010>
-- Create date: <23/02/2017>
-- Description:	<     >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON
DECLARE @RES integer,  @OldPrice float, @UserID int, @Q varchar(4000),@OldKmBetweenZone float;
DECLARE @isShowAllGeoRegion bit=0;
--@Base_Price float,
	if @R=1 /*   */
		begin
		--Select @Base_price=BASE_PRICE from PROPERTIES;
		SET @Q='SELECT zzz.*,ZF.NAMEZONE as NAMEZONEFROM,ZT.NAMEZONE as NAMEZONETO,';
		if (@Price IS NOT NULL) SET @Q=@Q+'STR(isnull('+CAST(@Price as varchar(16))+'*zzz.KmBetweenZone,0.0),10,0)';	 
			else SET @Q=@Q+'0';
		SET @Q=@Q+'as CalBasePrice FROM ZoneRange zzz LEFT JOIN ZONE ZF ON ZF.UNIKEY=zzz.ZONEFROM LEFT JOIN ZONE ZT ON ZT.UNIKEY=zzz.ZONETO';
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY ZoneFrom, ZoneTo';
		--EXEC sp_executesql @SQLString,N'@Price money=NULL',@Price;
		EXEC (@Q);
		return;
		end;
	if @R=2 /**/
		begin
		if @isSaveJournal=1 SELECT @OldPrice=Price,@OldKmBetweenZone=KmBetweenZone FROM ZoneRange where ZoneFrom=@ZoneFrom AND ZoneTo=@ZoneTo;
		UPDATE ZoneRange SET MinBetweenZone=@MinBetweenZone, Price=@Price, KmBetweenZone=@KmBetweenZone,
			DateUpdate=GETDATE() where ZoneFrom=@ZoneFrom AND ZoneTo=@ZoneTo;
		/*    */
		if @isSaveJournal=1 AND @OldPrice<>@Price
			begin
			SELECT @UserID=UniKey FROM Users WHERE UserName=SUSER_SNAME()
			INSERT INTO ZoneRangeJournal (ZoneFrom,ZoneTo, Price, OldPrice, UserID,TypeOfChange)
				 VALUES (@ZoneFrom,@ZoneTo, @Price, @OldPrice, @UserID,2);
			end;
		UPDATE TablesLastUpdate SET TLUZoneRange=GETDATE();
		return;
		end;
	if @R=3 /**/
		begin
		IF (EXISTS( SELECT * FROM ZoneRange WHERE ZoneFrom=@ZoneFrom AND ZoneTo=@ZoneTo))
			SELECT 0 ret;
			else
			begin
			INSERT INTO ZoneRange (ZoneFrom,ZoneTo,Price,KmBetweenZone,MinBetweenZone) VALUES 
				(@ZoneFrom,@ZoneTo,@Price,@KmBetweenZone,@MinBetweenZone);
			/*    */
			if @isSaveJournal=1
				begin
				SELECT @UserID=UniKey FROM Users WHERE UserName=SUSER_SNAME()
				INSERT INTO ZoneRangeJournal (ZoneFrom,ZoneTo, Price, OldPrice, UserID,TypeOfChange) VALUES (@ZoneFrom,@ZoneTo, @Price, 0, @UserID,1);
			UPDATE TablesLastUpdate SET TLUZoneRange=GETDATE();
			end;
			SELECT 1 ret;
			end;
		return;
		end;
	if @R=4 /**/
		begin
		if @isSaveJournal=1 SELECT @OldPrice=Price FROM ZoneRange where ZoneFrom=@ZoneFrom AND ZoneTo=@ZoneTo;
		DELETE FROM ZoneRange where ZoneFrom=@ZoneFrom  AND ZoneTo=@ZoneTo;
			/*    */
			if @isSaveJournal=1
				begin
				SELECT @UserID=UniKey FROM Users WHERE UserName=SUSER_SNAME()
				INSERT INTO ZoneRangeJournal (ZoneFrom,ZoneTo, Price, OldPrice, UserID,TypeOfChange) VALUES (@ZoneFrom,@ZoneTo, 0, @OldPrice, @UserID,3);
			end;		
		UPDATE TablesLastUpdate SET TLUZoneRange=GETDATE();
		return;
		end;
	if @R=5 /*    */
		begin
		SET @RES=0;
		-- ,     
		DELETE FROM ZoneRange WHERE Zoneto NOT IN (SELECT Unikey FROM ZONE WHERE UNIKEY=ZONETO);
		DECLARE Base_cursor CURSOR FOR 
		SELECT ZoneFrom,ZoneTo,Price, KmBetweenZone,MinBetweenZone FROM ZoneRange;
		OPEN Base_cursor

		FETCH NEXT FROM Base_cursor INTO @ZoneFrom,@ZoneTo,@Price,@KmBetweenZone, @MinBetweenZone
		WHILE @@FETCH_STATUS = 0
			BEGIN
			IF (NOT EXISTS( SELECT * FROM ZoneRange WHERE ZoneFrom=@ZoneTo AND ZoneTo=@ZoneFrom))
				begin
				INSERT INTO ZoneRange (ZoneFrom,ZoneTo,Price,KmBetweenZone,MinBetweenZone) VALUES (@ZoneTo,@ZoneFrom,@Price,@KmBetweenZone,@MinBetweenZone);
				/*    */
				if @isSaveJournal=1
					begin
					SELECT @UserID=UniKey FROM Users WHERE UserName=SUSER_SNAME()
					INSERT INTO ZoneRangeJournal (ZoneFrom,ZoneTo, Price, OldPrice, UserID,TypeOfChange) VALUES (@ZoneFrom,@ZoneTo, @Price, 0, @UserID,2);
				end;
				SET @RES=@RES+1;
				end;
			FETCH NEXT FROM Base_cursor 		INTO @ZoneFrom,@ZoneTo,@Price,@KmBetweenZone,@MinBetweenZone
			END

		CLOSE Base_cursor
		DEALLOCATE Base_cursor
		--  
		UPDATE TablesLastUpdate SET TLUZoneRange=GETDATE();
		SELECT @RES RES;
		return;
		end;
	if @R=6 /* */
		begin
		SET @Q='SELECT * FROM Zone ';
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY UNIKEY';
		Exec (@Q);
		return;
		end;
	if @R=7 /*  . */
		begin
		if(@UNIKEY=0)
			begin
			DECLARE Base_cursor CURSOR FOR 
				SELECT ZoneFrom,ZoneTo,Price FROM ZoneRange WHERE ZoneFrom=@ZoneFrom OR ZoneTo=@ZoneFrom OR @ZoneFrom IS NULL;
			end
			else
			if(@UNIKEY=1)
				begin
				DECLARE Base_cursor CURSOR FOR 
					SELECT ZoneFrom,ZoneTo,Price FROM ZoneRange WHERE ZoneFrom=@ZoneFrom OR @ZoneFrom IS NULL;
				end
				else
				if(@UNIKEY=2)
					begin
					DECLARE Base_cursor CURSOR FOR 
						SELECT ZoneFrom,ZoneTo,Price FROM ZoneRange WHERE ZoneTo=@ZoneFrom  OR @ZoneFrom IS NULL;
					end;
		OPEN Base_cursor

		FETCH NEXT FROM Base_cursor INTO @ZoneFrom,@ZoneTo,@OldPrice
		WHILE @@FETCH_STATUS = 0
			BEGIN
			UPDATE ZoneRange SET Price=(@OldPrice+@Price),DateUpdate=GETDATE() WHERE ZoneFrom=@ZoneFrom AND ZoneTo=@ZoneTo;
			/*    */
			if @isSaveJournal=1
				begin
				SELECT @UserID=UniKey FROM Users WHERE UserName=SUSER_SNAME()
				INSERT INTO ZoneRangeJournal (ZoneFrom,ZoneTo, Price, OldPrice, UserID,TypeOfChange) VALUES (@ZoneFrom,@ZoneTo, @Price+@OldPrice, @OldPrice, @UserID,2);
			end;
			FETCH NEXT FROM Base_cursor 		INTO @ZoneFrom,@ZoneTo,@OldPrice;
			END
		CLOSE Base_cursor
		DEALLOCATE Base_cursor
		--  
		UPDATE TablesLastUpdate SET TLUZoneRange=GETDATE();
		return;
		end;
	if @R=8	 /*   */
		begin
		INSERT INTO GeoRegions (NameGeoRegion,lat,lon,radius,OrderSrcWEB,isShowAsParking, isWEBAvailable) 
			VALUES (@NameGeoRegion,@lat,@lon,@radius,@OrderSrcWEB,@isShowAsParking,@isWEBAvailable);
		SET @UniKey=SCOPE_IDENTITY();
		return;
		end;
	if @R=9	 /*  /*/
		begin
		if EXISTS(SELECT * FROM BASE WHERE GeoFrom=@UniKey OR GeoTo=@UniKey)
			begin
			SET @SelectOrder=[dbo].[F_GET_LNG_MESSAGE]('DB_USED_IN_ORDERS'); --'  ,  !';
			SET @UniKey=0;
			end
			else
			begin
			UPDATE ZONE SET GeoRegion=NULL WHERE GeoRegion=@UniKey;
			UPDATE ROutesByPhone SET GeoRegionTo=NULL WHERE GeoRegionTo=@UniKey;
			DELETE FROM GeoRegions WHERE UniKey=@UniKey;
			SET @SelectOrder=NULL;
			end;
		return;
		end;
	if @R=10	 /*  */
		begin
		UPDATE GeoRegions SET NameGeoRegion=@NameGeoRegion,lat=@lat,lon=@lon,radius=@radius, 
			OrderSrcWEB=@OrderSrcWEB,isShowAsParking=@isShowAsParking, isWEBAvailable=@isWEBAvailable
			WHERE UniKey=@UniKey;
		return;
		end;
	if @R=11	 /*  */
		begin
		SET @Q='SELECT GR.* FROM GeoRegions GR WHERE 1=1';
		--    
		if (@CurrentUserUniKey IS NOT NULL)
			begin
			SELECT @isShowAllGeoRegion=isShowAllGeoRegion FROM USERS WHERE UniKey=@CurrentUserUniKey;
			if @isShowAllGeoRegion=0 SET @Q =@Q + ' AND GR.UniKey IN (SELECT GeoRegion FROM User_GeoRegion_Link WHERE UserKey='+CAST(@CurrentUserUniKey as varchar(12))+')';
			end;
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY GR.NameGeoRegion';
		Exec (@Q);
		return;
		end;
	if @R=12	 /*  */
		begin

		SET @Q='SELECT zzz.*,ggg.NameGeoRegion NameGeoRegion FROM ZONE zzz LEFT JOIN GeoRegions ggg ON ggg.Unikey=zzz.GeoRegion';
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY zzz.UNIKEY';
		Exec (@Q);
		return;
		end;
	if @R=13	 /*   */
		begin
		if EXISTS(SELECT * FROM ZONE WHERE UniKey=@UniKey)
			begin
			SELECT 0 ret;
			end
			else
			begin
			INSERT INTO Zone (UniKey,NAMEZONE,GeoRegion,Comment,lat,lon,radius,AddSum,PolygonColor,isShowAsParking)
				VALUES (@UniKey,@ZoneName,@ZoneFrom,@Comment,@lat,@lon,@radius,@AddSum,@PolygonColor,@isShowAsParking);
			SELECT @UniKey ret;
			end;
		return;
		end;
	if @R=14	 /*  */
		begin
		DELETE FROM Zone WHERE UniKey=@UniKey;
		DELETE FROM ZoneRange WHERE Zoneto=@UniKey;
		--  
		UPDATE TablesLastUpdate SET TLUZoneRange=GETDATE();
		return;
		end;
	if @R=15	 /*  */
		begin
		UPDATE Zone  SET NAMEZONE=@ZoneName,GeoRegion=@ZoneFrom,Comment=@Comment,lat=@lat,lon=@lon,
			radius=@radius,AddSum=@AddSum,PolygonColor=@PolygonColor,isShowAsParking=@isShowAsParking
			WHERE UniKey=@UniKey;
		return;
		end;
	if @R=16	 /*       N */
		begin
		SELECT ddd.UNIKEY,dbo.GetFIO(ddd.UNIKEY) as FIO,
		(SELECT GOV_NUMBER FROM Cars WHERE UniKey=[dbo].[GetCarByDriver](DDD.UNIKEY,GETDATE()))as GOV_NUMBER,
		dbo.GetCurrentTaxiNum(ddd.UNIKEY,GETDATE()) as TaxiNum,
			(SELECT NameGeoRegion FROM GeoRegions GR WHERE GR.UniKey=(SELECT GeoRegion FROM base bbb INNER JOIN ZONE ON bbb.ZoneTo=zone.unikey WHERE 
				bbb.UniKey=(SELECT MAX(PPP.UniKey) FROM base PPP WHERE
				DATEDIFF(mi,GETDATE(),DATEADD(mi,@ZoneFrom,PPP.DATEIN))>0 AND PPP.DRIVER=ddd.UniKey))) as NameGeoRegion,
			(SELECT Count(UniKey) FROM base WHERE DATEDIFF(mi,GETDATE(),DATEADD(mi,@ZoneFrom,DATEIN))>0 AND DRIVER=ddd.UniKey) as ZakazCount,
			(SELECT Namezone FROM Zone ZZZ WHERE ZZZ.UniKey=DP.Zone) as NAMEZONE
			FROM DRIVERS ddd LEFT JOIN DriversPlace DP ON DP.DRIVER=ddd.UniKey
			WHERE v_state=0 AND Exists(SELECT BPP.UniKey FROM base BPP WHERE DATEDIFF(mi,GETDATE(),DATEADD(mi,@ZoneFrom,BPP.DATEIN))>0 AND BPP.DRIVER=ddd.UniKey) ORDER BY FIO;
		return;
		end;
	if @R=18	 /*   */
		begin
		SET DATEFORMAT dmy;
		SET @Q='SELECT zzz.DATECHANGE, zzz.Price, zzz.OldPrice,(SELECT NAMEZONE FROM ZONE WHERE UNIKEY=zzz.ZoneFrom) NAMEZONEFROM,
			(SELECT NAMEZONE FROM ZONE WHERE UNIKEY=zzz.ZoneTO) NAMEZONETO,
			(SELECT FIO FROM Users WHERE UniKey=zzz.UserID) UserFIO, zzz.TypeOfChange, zzz.ZoneFrom, zzz.ZoneTo,zzz.UniKey
			FROM ZoneRangeJournal zzz WHERE 1=1';
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY  NameZoneFrom, NameZoneTo';
		--RaISERROR 99999 @Q;
		Exec (@Q);
		return;
		end;
	if @R=19 /*  */
		begin
		DELETE FROM ZoneRangeJournal WHERE UniKey=@UniKey;
		return;
		end;
	if @R=20 /*   */
		begin
		SELECT @UniKey=MAX(UniKey) FROM Zone;
		SET @UniKey=isnull(@UniKey,0);
		return;
		end;
	if @R=21 /*    */
		begin
		SELECT ZoneNear,NameZone FROM ZoneNear LEFT JOIN Zone ON Zone.Unikey=ZoneNear.ZoneNear WHERE ZoneNear.ZoneMain=@Unikey
			ORDER BY NameZone;
		return;
		end;
	if @R=22 /*    */
		begin
		INSERT INTO ZoneNear (ZoneNear,ZoneMain) Values (@ZoneFrom,@Unikey);
		return;
		end;
	if @R=23 /*    */
		begin
		DELETE FROM ZoneNear WHERE ZoneNear=@ZoneFrom AND ZoneMain=@Unikey;
		return;
		end;
	if @R=24 /*   */
		begin
		SELECT * FROM ZoneNear;
		return;
		end;
	if @R=25	--  
		begin
		if(NOT EXISTS (SELECT * FROM ZoneRect WHERE Zone=@ZoneFrom AND lat=@lat AND lon=@lon))
			begin
			INSERT INTO ZoneRect (Zone,lat,lon)VALUES(@ZoneFrom,@lat,@lon);
			SET @UniKey=SCOPE_IDENTITY();
			end;
		return;
		end;
	if @R=26	--    
		begin
		SELECT * FROM ZoneRect WHERE Zone=@ZoneFrom;
		return;
		end;
	if @R=27	--    
		begin
		UPDATE ZoneRect SET lat=@lat, lon=@lon WHERE UniKey=@UniKey;
		return;
		end;
	if @R=28 /*    */
		begin
		DELETE FROM ZoneRect WHERE UniKey=@UniKey;
		return;
		end;
	if @R=29 --    
		begin
		SELECT ZR.*,ZZZ.GeoRegion FROM ZoneRect ZR
			LEFT JOIN Zone ZZZ ON ZR.Zone=ZZZ.UNIKEY
			ORDER BY ZR.UniKey;
		return;
		end;
	if @R=30 /*     */
		begin
		DELETE FROM ZoneRect WHERE Zone=@ZoneFrom;
		return;
		end;
	if @R=31 /*       /*/
		begin
		UPDATE COD_HOUSE SET isNeedValidate=1 
			WHERE Street IN (SELECT UniKey FROM COD_STREET WHERE Zone IN (SELECT UniKey FROM ZOne WHERE GeoRegion=@UniKey));
		SELECT @RES=Count(*) FROM COD_HOUSE
			WHERE Street IN (SELECT UniKey FROM COD_STREET WHERE Zone IN (SELECT UniKey FROM ZOne WHERE GeoRegion=@UniKey));
		SET @UniKey=isnull(@RES,0);
		return;
		end;
	-- 
	if @R=32
		begin
		SELECT * FROM ZoneRange;
		return;
		end;
END;