ALTER PROCEDURE [dbo].[P_FILES_RADIO](@R int=1,
@UniKey	int=null OUTPUT,
@FromUserKey	int=null,
@FromDriverKey	int=null,
@Direction		int=null,
@isChecked		bit=null,
@CheckedUser	int=null,
@CheckedDate	datetime=null,
@Userkey		int=null,
@isCorrupt		bit=null,
@FRGKey			int=null,
@GROUP			int=null,
@DriverRecipientKey	int=null,
@FileSize		int=null,		-- 
@Path			varchar(256)=null,
@RESULT			varchar(128)=null OUTPUT,
@SelectOrder	varchar(1024)=null
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <02.06.2016>
-- Update date: <17.10.2016>
-- Description:	<     >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON;
	DECLARE @Q varchar(4000), @KeyTmp int,@KeyTmp2 int,@isShowAllGeoRegion bit=1, @isShowAllZakazType bit=1,@UserGroupKey int=null;
	--
	if @R=1
		begin
		if (@Userkey IS NOT NULL)
			begin
			SELECT @UserGroupKey=UserGroupKey, @isShowAllZakazType=isShowAllZakazType, @isShowAllGeoRegion=isShowAllGeoRegion FROM USERS WHERE UniKey=@UserKey;
			end;
		SET @Q='SELECT FR.*,U1.FIO as FromUserNAME, U2.FIO as CheckedUserNAME, D.FA as DriverNAME,FRD.DirectionName,
(SELECT COUNT(*) FROM FilesRadioDelivery FRD WHERE FRD.FRKey=FR.Unikey) as DRIVERS_COUNT,
(SELECT COUNT(*) FROM FilesRadioDelivery FRD WHERE FRD.FRKey=FR.Unikey AND FRD.DeliveryState=2) as DRIVERS_COUNT_LISTEN,
(SELECT COUNT(*) FROM FilesRadioDelivery FRD WHERE FRD.FRKey=FR.Unikey AND FRD.DeliveryState=3) as DRIVERS_COUNT_REJECTED FROM FIlesRadio FR LEFT JOIN USERS U1 ON U1.UniKey=FR.FromUserKey LEFT JOIN USERS U2 ON U2.UniKey=FR.CheckedUser LEFT JOIN DRIVERS D ON D.UNIKEY=FR.FromDriverKey LEFT JOIN FilesRadioDirections FRD ON FRD.DirectionKey=FR.Direction AND FRD.Lng LIKE (SELECT LngMain FROM PROPERTIES) ';
		--  ,    
		if(@UserGroupKey IS NOT NULL) SET @Q=@Q+' INNER JOIN UsersGroupsDrivers UGD ON UGD.UserGroupKey='+CAST(@UserGroupKey as varchar(16))+' AND (UGD.DriverKey=FR.FromDriverKey OR UGD.DriverKey IN (SELECT DriverKey FROM FilesRadioDelivery FRD WHERE FRD.FRKey=FR.Unikey))';
		
		SET @Q=@Q+' WHERE 1=1';
		if @UniKey IS NOT NULL SET @Q=@Q+' AND FR.UniKey='+CAST(@UniKey as varchar(16));
		if @FromDriverKey IS NOT NULL SET @Q=@Q+' AND (FR.FromDriverKey='+CAST(@FromDriverKey as varchar(16))+' OR EXISTS(SELECT 1 FROM FilesRadioDelivery FRD1 WHERE FRD1.FRKey=FR.UniKey AND FRD1.DriverKey='+CAST(@FromDriverKey as varchar(16))+'))';

		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY FR.DateCreate DESC';
		Exec (@Q);
		return;
		end;
	--    
	if @R=2
		begin
		SELECT [Path] as [PATH] FROM FilesRadio WHERE UniKey=@UniKey;
		return;
		end;
	--    
	if @R=3
		begin
		if(@Direction IS NULL)
			begin
			IF @FromDriverKey IS NULL SET @Direction=1;
			IF @FromDriverKey IS NOT NULL 
				BEGIN
				IF(@GROUP IS NOT NULL OR @DriverRecipientKey IS NOT NULL) SET @Direction=3;
					ELSE SET @Direction=2;
				END;
			end;
		if (@UniKey IS NULL)
			begin
			-- 
			INSERT INTO FilesRadio (FromUserKey,FromDriverKey,Direction,FileSize)
				VALUES (@FromUserKey,@FromDriverKey,@Direction,@FileSize);
			SET @KeyTmp=SCOPE_IDENTITY();
			-- -  
			IF @DriverRecipientKey IS NOT NULL
				begin
				INSERT INTO FilesRadioDelivery(DriverKey,FRKey)VALUES(@DriverRecipientKey,@KeyTmp);
				end;
			SET @Path=REPLACE(@Path,'[FILEKEY]',CAST(@KeyTmp as varchar(16)));
			end
			else
			begin
			SET @KeyTmp=@UniKey;
			end;
		UPDATE FilesRadio SET [Path]=@Path WHERE UniKey=@KeyTmp;
		IF @FileSize IS NOT NULL
			UPDATE FilesRadio SET FileSize=@FileSize WHERE UniKey=@KeyTmp;
		SELECT @KeyTmp as RESULT, 1 as blabla;
		return;
		end;
	--,    
	if @R=4
		begin
		UPDATE FilesRadio SET isChecked=1, CheckedDate=GETDATE(), CheckedUser=@Userkey
			WHERE UniKey=@UniKey AND isChecked=0;
		return;
		end;
	--         
	if @R=5
		begin
		SELECT FRD.*,[dbo].[GetFIO](FRD.DriverKey) as DriverName,DS.StateName
			FROM FilesRadioDelivery FRD WITH(READPAST)
			LEFT JOIN FilesRadioDeliveryState DS ON DS.DSKey=FRD.DeliveryState AND DS.Lng LIKE (SELECT LngMain FROM PROPERTIES)
			WHERE FRD.FRKey=@UniKey;
		return;
		end;
	-- 1 - 
	if @R=6
		begin
		INSERT INTO FilesRadioDelivery (FRKey,DriverKey)VALUES(@Unikey,@FromDriverKey);
		return;
		end;
	if @R=7 /*  */
		begin
		SET @KeyTmp=@UniKey;
		SET @KeyTmp2=NULL;
		SELECT @KeyTmp2=LockUser FROM FilesRadio WITH (readpast) WHERE UniKey=@KeyTmp;
		if (@Userkey IS NOT NULL)
			begin
			if(@KeyTmp2 IS NULL)
				begin
				UPDATE FilesRadio SET LockUser=@Userkey WHERE UniKey=@KeyTmp;				
				SET @RESULT=NULL;
				end 
				else 
				begin
				SELECT @RESULT=FIO FROM USERS WITH(readpast) WHERE UniKey=@KeyTmp2;
				end;
			end
			else
			UPDATE FilesRadio SET LockUser=NULL WHERE UniKey=@KeyTmp;
		return;
		end;		
	--    
	if @R=8
		begin
		SELECT GM.DriverKey as DriverKeyMember, G.DriverKey as DriverKeyOwner,GM.FRGKey,G.GroupName,GM.NickName 
			FROM FilesRadioGroupMember GM 
			LEFT JOIN FilesRadioGroup G ON G.UniKey=GM.FRGKey
			LEFT JOIN DRIVERS D ON D.UNIKEY=G.DriverKey
			WHERE D.v_state=0
		return;
		end;
	--   
	if @R=9
		begin
		--     
		IF NOT EXISTS(SELECT 1 FROM FilesRadioGroup FRG WHERE FRG.DriverKey=@UniKey AND FRG.UniKey=@FRGKey)
			return;
		
		if NOT EXISTS(SELECT 1 FROM FilesRadioGroupMember GM WHERE GM.DriverKey=@FromDriverKey AND FRGKey=@FRGKey)
			begin
			INSERT INTO FilesRadioGroupMember (DriverKey,FRGKey) VALUES (@FromDriverKey,@FRGKey)
			UPDATE TablesLastUpdate SET TLU_FILES_RADIO_GROUP_MEMBERS=GETDATE();
			end;
		return;
		end;
	--   
	if @R=10
		begin
		SELECT G.DriverKey as DriverKeyOwner,G.UniKey as FRGKey,G.GroupName 
			FROM FilesRadioGroup G 
			LEFT JOIN DRIVERS D ON D.UNIKEY=G.DriverKey
			WHERE D.v_state=0
		return;
		end;
		
	--,      "" 
	if @R=11
		begin
		UPDATE FilesRadio SET isChecked=1, CheckedDate=GETDATE(), CheckedUser=@Userkey,isCorrupt=1
			WHERE UniKey=@UniKey;
		return;
		end;
END
