// Copyright 2017 The NooRex. All rights reserved.

var hostName = "noorex_native_host";
var port = null;
var port_ext=null;
var isShowLog=false;
function onDisconnectedExt() {
  port_ext = null;
  if(!port) port.disconnect;
}

browser.runtime.onConnect.addListener(function(port_ext1) {
	port_ext=port_ext1;
  port_ext1.onMessage.addListener(function(msg) {
	if(isShowLog) console.log("onMessage send (background):"+msg);
	if (!port) 
	{
		if(!connect())
		{
			port_ext.postMessage("Connect (background)native message host error");
			return;
		}
	}
	sendNativeMessage(msg);
  });
  port_ext1.onDisconnect.addListener(onDisconnectedExt);
});

function sendNativeMessage(message) {
	if (!port) {
		if(isShowLog) console.log("sendNativeMessage (background) error");
		return;
	}
	var msg=new String(message)
  port.postMessage(message);
}
function onNativeMessage(message) {
	if(isShowLog) console.log("onNativeMessage recieve (background)");
  if(port_ext) 
	port_ext.postMessage(message);
	else
	alert("FireFox connection error to NooRex messaging host. Reload page.");
}
function onDisconnected() {
  port = null;
}
function connect() {
  port = browser.runtime.connectNative(hostName);
  if(!port) {
	console.log("NooRex Plugin Connect (background) error");
	return false;
  }
  port.onMessage.addListener(onNativeMessage);
  port.onDisconnect.addListener(onDisconnected);
	if(isShowLog) console.log("Connect (background) success");
  return true;
}
