@echo off
:: Copyright 2015-2017 The NooRex Authors. All rights reserved.
:: Use of this source code is governed by a BSD-style license that can be
:: found in the LICENSE file.

:: Change HKCU to HKLM if you want to install globally.
:: %~dp0 is the directory containing this bat script and ends with a backslash.

REG ADD "HKLM\Software\Google\Chrome\NativeMessagingHosts\com.native.noorex.host" /ve /t REG_SZ /d "%~dp0com.native.noorex.host-win-chrome.json" /f
REG ADD "HKCU\Software\Google\Chrome\NativeMessagingHosts\com.native.noorex.host" /ve /t REG_SZ /d "%~dp0com.native.noorex.host-win-chrome.json" /f
REG ADD "HKCU\SOFTWARE\Mozilla\NativeMessagingHosts\noorex_native_host" /ve /d "%~dp0com.native.noorex.host-win-firefox.json" /f
REG ADD "HKLM\SOFTWARE\Mozilla\NativeMessagingHosts\noorex_native_host" /ve /d "%~dp0com.native.noorex.host-win-firefox.json" /f

::FF version <52
REG ADD "HKCU\SOFTWARE\MozillaPlugins\@noorex.com/np_otaxi_browser" /v Path /t REG_SZ /d "%~dp0np_otaxi_browser.dll" /f
REG ADD "HKCU\SOFTWARE\MozillaPlugins\@noorex.com/np_otaxi_browser" /v ProductName /t REG_SZ /d "np_otaxi_browser" /f
REG ADD "HKCU\SOFTWARE\MozillaPlugins\@noorex.com/np_otaxi_browser" /v Vendor /t REG_SZ /d "noorex.com" /f
REG ADD "HKCU\SOFTWARE\MozillaPlugins\@noorex.com/np_otaxi_browser" /v Version /t REG_SZ /d "2.3.0.4" /f
regsvr32 /s np_otaxi_browser.dll

if defined PROCESSOR_ARCHITEW6432 (goto LABEL_X64)
if %PROCESSOR_ARCHITECTURE%==IA64 (goto LABEL_X64)
if %PROCESSOR_ARCHITECTURE%==AMD64 (goto LABEL_X64)
if %PROCESSOR_ARCHITECTURE%==x86 (goto LABEL_X86)
goto LABEL_NON

:LABEL_X64
echo OS type: x64
REG ADD "HKLM\Software\Wow6432Node\Google\Chrome\Extensions\fjmcjbdomdgbecpohgghpceapaenjabi" /v update_url /t REG_SZ /d "https://clients2.google.com/service/update2/crx" /f /reg:64

::FF version <52
REG ADD "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\MozillaPlugins\@noorex.com/np_otaxi_browser" /v Path /t REG_SZ /d "%~dp0np_otaxi_browser.dll" /f
REG ADD "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\MozillaPlugins\@noorex.com/np_otaxi_browser" /v ProductName /t REG_SZ /d "np_otaxi_browser" /f
REG ADD "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\MozillaPlugins\@noorex.com/np_otaxi_browser" /v Vendor /t REG_SZ /d "noorex.com" /f
REG ADD "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\MozillaPlugins\@noorex.com/np_otaxi_browser" /v Version /t REG_SZ /d "2.3.0.4" /f

goto LABEL_END

:LABEL_X86
echo OS type: x86
REG ADD "HKLM\Software\Google\Chrome\Extensions\fjmcjbdomdgbecpohgghpceapaenjabi" /v update_url /t REG_SZ /d "https://clients2.google.com/service/update2/crx" /f
goto LABEL_END

:LABEL_NON
echo OS type: undefined
goto LABEL_END

:LABEL_END 


