ALTER PROCEDURE [dbo].[ProcCloseOrderInFlight](@R int=1,@UniKey int=null,
@TAXINUM int=0,					--
@CLIENTTEL varchar(32)=null,	--  
@OtkazClienta int=null,			--  
@OldDRIVER int=null,			--    
@ZoneFrom int=null,				-- 
@ZoneTo int=null,				-- 
@OldOtkazClienta int=NULL,		--   
@ZakazPlace int=NULL,			--
@OldZakazPlace int=NULL			-- 
) AS
begin
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <18.11.2009>
-- Update date: <11.10.2016>
-- Description:	<     >
-- =============================================
SET DATEFORMAT dmy;
DECLARE @StatRefusal int, @StatCallAll int, @CurContract int, @TMP int, @TMP2 int,
	@DateIn datetime, @hourpay int,@isKmEnabled bit,@HourPayAddMin int,@HourPayZakazPlace int,
	@isEnabledDiscountByVIP bit=0, @isEnabledDiscountByPhone bit=0,@ZakazPlaceBegin int=NULL, @isManual bit=0,
	@UltraKey int=null, @isOwn bit=1, @PriceFull money, @Price money=0, @PhoneKey int, @ZakazPlaceDateTaxiWait int, 
	@ZakazPlaceDateTaxiGo int,@VIP int=null, @isTaximeter bit=0, @isDiscount bit=0, @TimeToClient int,
	@Card int, @isClearing bit, @LPSrc int, @UltraAutoSendOrderState int, @UltraExchange int, @isPredv bit,
	@VarChar1 varchar(128),@VarChar2 varchar(128), @DateBegin datetime;
DECLARE @Driver int=NULL; --    ,    	
DECLARE @PhonePrefix varchar(20)=NULL, @IS_USE_AUDIO_ROBOT bit;
DECLARE @OldisError bit, @isError bit,@isInterCity bit;
DECLARE		@SMS_Pattern_link int,@SmsText varchar(512),@PhoneType int, @SMS int, @IS_SMS_ENABLED bit;
DECLARE @JCloseOtkazRestoreQueue bit, @DiscountsCumulativeActionsCount int;

DECLARE @ModuleType int, @isOtkazClienta int,@isAudioRobotEnabledPhone bit=1,
				@Audio_Pattern int=null, @isAudioRobotEnabled bit=null,@isOnlyPhoneType bit=0,
				@isTimeToClientAudioPatternExists bit=0,
@LegalPerson int,						--  ,    
@isUseExchangeOrg bit=0,				--   
@LPExchangeRelationsKey	int=null,		-- ,    ( )
@LPExchangeRelationsCommission	money=0,--    
@ZAKAZ_PLACE_ACTIONS_COUNT		int;	--     

	--  ?
	if @R=1
		begin
		DECLARE MyCursor CURSOR FAST_FORWARD FOR
			SELECT UniKey,ClientTel,ZakazPlace,OtkazClienta,Driver,ZoneFrom,ZoneTo FROM BASE WITH (readpast) WHERE LOCKBAS=0 AND TAXINUM=@TAXINUM AND ZakazPlace=8
			FOR READ ONLY;
		OPEN MyCursor
		FETCH NEXT FROM MyCursor INTO @UniKey,@CLIENTTEL,@ZakazPlace,@OtkazClienta,@DRIVER,@ZoneFrom,@ZoneTo;
		WHILE @@FETCH_STATUS = 0
			BEGIN
			--     
			if NOT EXISTS(SELECT Unikey FROM DriversPlace WITH (readpast) WHERE isOnline=1 AND ClientType=1 AND Driver=@Driver)
				begin
				UPDATE base SET ZakazPlace=100 WHERE UNIKEY=@UniKey;
				exec [ProcCloseOrderInFlight] 2,@UniKey,@TAXINUM,@CLIENTTEL,@OtkazClienta,@Driver,@ZoneFrom,@ZoneTo,@OtkazClienta,100,@ZakazPlace;
				Exec [dbo].[history_up] @R=3,@BaseKey=@UniKey,@UserKey=NULL,@ActionKey=100;
				end;
			FETCH NEXT FROM MyCursor INTO @UniKey,@CLIENTTEL,@ZakazPlace,@OtkazClienta,@DRIVER,@ZoneFrom,@ZoneTo;
		END;
		CLOSE MyCursor;
		DEALLOCATE MyCursor;
		return;
		end;
	if @R=2
		begin
		SELECT TOP 1 @isEnabledDiscountByPhone=isEnabledDiscountByPhone, 
				@isUseExchangeOrg=isUseExchangeOrg,@JCloseOtkazRestoreQueue=JCloseOtkazRestoreQueue,
				@isAudioRobotEnabled=isAudioRobotEnabled,@ZakazPlaceBegin=ZakazPlaceBegin,
				@ZakazPlaceDateTaxiWait=ZakazPlaceDateTaxiWait,@ZakazPlaceDateTaxiGo=ZakazPlaceDateTaxiGo,
				@UltraAutoSendOrderState=UltraAutoSendOrderState,@HourPayZakazPlace=HourPayZakazPlace,@HourPayAddMin=HourPayAddMin,
				@isEnabledDiscountByVIP=isEnabledDiscountByVIP FROM PROPERTIES;
		
		--     
		SELECT @Driver=Driver, @PhoneKey=PhoneKey,@VIP=vip,@DateIn=DateIn,
			@UltraKey=UltraKey, @isOwn=isOwn, @Price=Price, @PriceFull=PriceFull, @isTaximeter=isTaximeter,
			@isDiscount=isDiscount,@TimeToClient=TimeToClient, @hourpay=hourpay, @isKmEnabled=isKmEnabled,
			@isClearing=isClearing, @LPSrc=LPSrc, @UltraExchange=UltraExchange,@ModuleType=ModuleType,@isPredv=isPredv,
			@LegalPerson=L1.LP, @isError=ZET.IsError,@isInterCity=isInterCity, @IS_USE_AUDIO_ROBOT=IS_USE_AUDIO_ROBOT
			from BASE as bbb WITH (readpast) 
			LEFT JOIN LPSrc L1 ON L1.UniKey=bbb.LPSrc
			LEFT JOIN ZakazExitType ZET ON ZET.UniKey=@OtkazClienta
			where bbb.UNIKEY=@UniKey;
		SET @OldisError=isnull([dbo].[isZakazExitError] (@OldOtkazClienta),0);
		/*    */
		if ((@ClientTel IS NOT NULL) AND (LEN(@ClientTel)>0) AND ((@OldZakazPlace=100) OR (@ZakazPlace=100))) 
			begin
			SET @StatRefusal=0;
			SET @StatCallAll=0;
			
			if ((@OldZakazPlace=100) AND (@ZakazPlace=100) AND (@OldisError=1) AND (@isError=0) ) 
				begin	 SET @StatCallAll=0; SET @StatRefusal=-1 end;
			if ((@OldZakazPlace=100) AND (@ZakazPlace=100) AND (@OldisError=0) AND (@isError=1) ) 
				begin	 SET @StatCallAll=0; SET @StatRefusal=1 end;
			if ((@OldZakazPlace!=100) AND (@ZakazPlace=100) AND (@isError=1) ) 
				begin	 SET @StatCallAll=1; SET @StatRefusal=1 end;
			if ((@OldZakazPlace!=100) AND (@ZakazPlace=100) AND (@isError=0) ) 
				begin	 SET @StatCallAll=1; SET @StatRefusal=0 end;
			if ((@OldZakazPlace=100) AND (@ZakazPlace!=100) AND (@OldisError=0) ) 
				begin	 SET @StatCallAll=-1; SET @StatRefusal=0 end;
			if ((@OldZakazPlace=100) AND (@ZakazPlace!=100) AND (@OldisError=1) ) 
				begin	 SET @StatCallAll=-1; SET @StatRefusal=-1 end;		
			-- 
			if (@StatCallAll!=0 OR @StatRefusal!=0)
				begin
				DECLARE @PhoneKeyNew int=@PhoneKey;
				-- 
				Exec ModifyPhoneStats @ClientTel, @StatCallAll, @StatRefusal,@PhoneKeyNew OUTPUT;
				--   
				if (@PhoneKey IS NULL) UPDATE BASE SET PhoneKey=@PhoneKeyNew WHERE UNIKEY=@UniKey;
				end;
			end;
		--   WEB 
			if EXISTS(SELECT UniKey FROM web WHERE Zakaz=@UniKey)
				begin
				UPDATE web SET OrderState=@ZakazPlace WHERE Zakaz=@UniKey; 
				if (@ZakazPlace=100) 
						begin
							UPDATE web SET isClosed=1 WHERE Zakaz=@UniKey;
							--  ,      
							if (@Driver IS NULL) UPDATE web SET isReject=1 WHERE Zakaz=@UniKey; 
						end
						else 
						begin
							-- ,   
							if (@OldZakazPlace=100) UPDATE web SET isClosed=0,isReject=0 WHERE Zakaz=@UniKey; 
						end;
				end;
		/*  */
		if (@Driver IS NOT NULL)
			begin
			DECLARE @isFreeCur bit;
			SELECT @isManual=ISNULL(isManual,0) FROM DriversPlace WITH (nolock) WHERE Driver=@Driver;
			if @isManual=0
				begin
				if Exists(SELECT Driver FROM BASE WITH (nolock) WHERE Driver=@Driver AND ZAKAZPLACE<100 AND NOT (isPredv=1 AND ZAKAZPLACE=11))
					SET @isFreeCur=0; else SET @isFreeCur=1;
				end
				else
				SELECT @isFreeCur=ISNULL(isFree,1) FROM DriversPlace WITH(nolock) WHERE Driver=@Driver;		
				--SET @isFreeCur=ISNULL(@isFreeCur,1);
			--  
			if (@ZakazPlace!=@OldZakazPlace)
				begin
				SELECT @TMP=ToZone FROM ZAKAZ_PLACE WITH(nolock) WHERE ZPLACE=@ZakazPlace;
				DECLARE @GeoRegionN int;
				if @TMP=1 
					begin
					--
					SELECT TOP 1 @GeoRegionN=GeoRegion FROM Zone WHERE  Unikey=@ZoneFROM;
					Exec P_Drivers_Actions @R=10,@Zone=@ZoneFROM,@GeoRegion=@GeoRegionN,@Driver=@Driver,@isManual=0;
					end;
				if @TMP=2 AND @isError=0
					begin
					--     
					SELECT TOP 1 @GeoRegionN=GeoRegion FROM Zone WITH(nolock) WHERE  Unikey=@ZoneTo;
					Exec P_Drivers_Actions @R=10,@Zone=@ZoneTo,@GeoRegion=@GeoRegionN,@Driver=@Driver,@isManual=0;
					end;

				--    
				DECLARE @isDriverToEndQueue bit;
				SELECT @isDriverToEndQueue=isDriverToEndQueue FROM ZAKAZ_PLACE WITH(readpast) WHERE ZPLACE=@OldZakazPlace;
				if (@isDriverToEndQueue=1 AND @Driver IS NOT NULL)
					begin
					--        
					if(isnull(@OldDRIVER,0)!=@Driver) UPDATE DriversPlace SET PrevQueue=[Queue] WHERE Driver=@Driver;
					--  
					--UPDATE DriversPlace SET [Queue]=ISNULL((SELECT MAX([Queue]) FROM DriversPlace WITH (nolock)),1)+1,DateUpdate=GETDATE() WHERE Driver=@Driver;
					BEGIN TRANSACTION;
					EXEC [dbo].[P_Drivers_Actions] @R=42,@Driver=@Driver;
					COMMIT TRANSACTION;
					end;
				--       
				if(@isError=1 AND @ZakazPlace=100)
					begin
					if (@JCloseOtkazRestoreQueue=1) UPDATE DriversPlace SET [Queue]=PrevQueue WHERE Driver=@DRIVER;
					end;
				-- 
				if(@isError=0 AND @ZakazPlace=100) 
					begin
					exec [P_DriverRatingAdd] @Driver, @LPSrc,@isPredv, @isClearing, @isDiscount;
					end;
				end;
			UPDATE DriversPlace SET ZAKAZPLACE=@ZakazPlace,isFree=@isFreeCur WHERE Driver=@Driver;
			end;	--(@Driver IS NOT NULL)
------------------------------------------------		
			--    
			if(@isTaximeter=1 AND ((@OldDRIVER IS NOT NULL AND @Driver IS NULL) OR
				 (@OldDRIVER IS NOT NULL AND @Driver IS NOT NULL AND @OldDRIVER!=@Driver)))
				begin
				DELETE FROM GPXCalc WHERE Zakaz=@UniKey;
				end;
------------------------------------------------		
		if (@ZakazPlace!=@OldZakazPlace)
			begin
			--     
			UPDATE BASE SET DATETIME_OF_T=GETDATE() WHERE UNIKEY=@UniKey;
			
			/*  SMS   */
			SET @SMS_Pattern_link=NULL;
			SET @IS_SMS_ENABLED=1;		--/     
			--   -  
			if (@PhoneKey IS NOT NULL)
				SELECT @PhoneType=PhoneType,@isAudioRobotEnabledPhone=isAudioRobotEnabled,
					@IS_SMS_ENABLED=IS_SMS_ENABLED FROM BLACKLISTTEL WITH (readpast) WHERE UniKey=@PhoneKey;
				else
				SELECT @PhoneType=PhoneType,@isAudioRobotEnabledPhone=isAudioRobotEnabled,
					@IS_SMS_ENABLED=IS_SMS_ENABLED FROM BLACKLISTTEL WITH (readpast) WHERE NUMTEL=@CLIENTTEL;
			if (@PhoneType IS NULL) 
				begin
				SET @PhoneType=dbo.isPhoneInternational(@ClientTel);
				SET @isAudioRobotEnabledPhone=1;
				end;
			if (@PhoneType=0) AND (@IS_SMS_ENABLED=1) AND (@CLIENTTEL IS NOT NULL)
				begin
				-- 
				SET @SMS_Pattern_link=[dbo].[F_GET_SMS_PATTERN_OUT_BY_ORDER](@UniKey,0,@ZakazPlace,1);
				IF (@SMS_Pattern_link IS NOT NULL)
					begin
					SET @SmsText=[dbo].[GetSMSTextByPattern](@UniKey,@SMS_Pattern_link);
					--  SMS  
					DECLARE @SMSChannel int=NULL;
					SELECT @SMSChannel=SMSChannel FROM LPSrc with(nolock) WHERE UniKey=@LPSrc;
					--     SMS
					INSERT INTO SMS (SmsState,SmsText,Phone,InOut,[Priority],Channel) VALUES (2,@SmsText,
						[dbo].[GetPhoneFromPatternS](@CLIENTTEL,1,NULL,1,NULL,NULL,NULL),1,1,@SMSChannel);
					SET @SMS=SCOPE_IDENTITY();
					INSERT INTO SMSZakazLink (zakaz,sms,UserID) VALUES (@UniKey,@SMS,dbo.GetCurrentUserUniKey());
					end;
				end; --  - 

			/*     */
			if (@ZakazPlaceBegin=@ZakazPlace) UPDATE BASE SET DateBegin=GETDATE() WHERE UNIKEY=@UniKey;

			/*    */
			if (@ZakazPlaceDateTaxiWait=@ZakazPlace) UPDATE BASE SET DateTaxiWait=GETDATE() WHERE UNIKEY=@UniKey;

			/*      */
			if (@ZakazPlaceDateTaxiGo=@ZakazPlace) UPDATE BASE SET DateTaxiGo=GETDATE() WHERE UNIKEY=@UniKey;

			/*         */
			if(@isAudioRobotEnabled=1 AND @isAudioRobotEnabledPhone=1 AND (@IS_USE_AUDIO_ROBOT=1) AND
				(@PhoneKey IS NOT NULL OR LEN(isnull(@CLIENTTEL,''))>0))
				begin
				--  . 
				SET @Audio_Pattern=[dbo].[F_GET_AUDIO_PATTERN_OUT_BY_ORDER](@UniKey,1,0,1);
				if (@Audio_Pattern IS NOT NULL)
					begin
					--if @PhoneKey IS NOT NULL
					--       
					IF (EXISTS(SELECT * FROM Audio_Pattern_link APL WHERE APL.AudioPattern=@Audio_Pattern AND APL.AudioPatternType=4))
						SET @isTimeToClientAudioPatternExists=1;
					if (@TimeToClient>0 OR 	(@TimeToClient=0 AND @isTimeToClientAudioPatternExists=0))
						begin
						--   
						if(LEN(@CLIENTTEL)>0)
							begin
							--   
							SELECT @PhonePrefix=PhonePrefix FROM LPSrc WHERE UniKey=@LPSrc;
							if (@PhonePrefix IS NOT NULL)
								begin
								SET @PhonePrefix=@PhonePrefix+[dbo].[GetPhoneFromPatternS](@CLIENTTEL,1,NULL,NULL,1,NULL,NULL);
								end
								else		
								SET @PhonePrefix=[dbo].[GetPhoneFromPatternS](@CLIENTTEL,1,NULL,NULL,1,NULL,NULL);
							INSERT INTO PhoneHistoryAutoRobot ([State],InOut,Phone,Zakaz,Audio_Pattern,PhoneKey) VALUES
								(6,1,@PhonePrefix,@UniKey,@Audio_Pattern,@PhoneKey);
							end;
						end
					end;
				end;--
			end;
		-- -   
		IF (@hourpay>0 OR @isKmEnabled=1)
				begin
				if @HourPayZakazPlace IS NOT NULL
					begin
					if (@ZakazPlace=@HourPayZakazPlace) UPDATE BASE SET DateBeginHourPay=DATEADD(mi,@HourPayAddMin,GETDATE()) WHERE UniKey=@UniKey;
					end;
				end;
		--       
		if (@UltraKey IS NOT NULL) AND (@isOwn=0)
				begin
				if @isError=1 
					SELECT @VarChar2=ZT.ZakazExitName FROM ZakazExitType ZT WHERE UniKey=@OtkazClienta;
					else
					SET @VarChar2=NULL;
				SELECT @VarChar1=UltraOrderId FROM UltraBaseIn WHERE OrderID=@UltraKey AND UltraExchange=@UltraExchange;
				exec [dbo].[P_Ultra] @R=3, @OrderId=@UltraKey, @StatusId=@ZakazPlace, @Command=2, @Price=@Price, 
					@UltraExchange=@UltraExchange, @VarChar1=@VarChar1,@ValueInt2=@Driver, @ValueInt1=@OldDRIVER,
					@VarChar2=@VarChar2;
				end;
		--         
		if (@UltraKey IS NULL) AND (@isOwn=1) AND (@UltraAutoSendOrderState IS NOT NULL) AND (@UltraAutoSendOrderState=@ZakazPlace)
				AND (@Driver IS NULL)
				begin
				SET @UltraExchange=NULL;
				SELECT @UltraExchange=UEKey FROM UltraExchange WHERE isEnabled=1 AND toSend=1;
				if(@UltraExchange IS NOT NULL)
					exec [dbo].[P_Ultra] @R=3, @OrderId=@UniKey, @StatusId=@ZakazPlace, @Command=5, @Price=@Price, @UltraExchange=@UltraExchange;
				end;	
		--    -     
		if (@UltraKey IS NOT NULL) AND (@isOwn=0)  AND (isnull(@Driver,0)!=isnull(@OldDRIVER,0))
			begin
			DECLARE @GOV_NUMBER varchar(128),@GOV_NUMBER_Short varchar(128);
			SELECT TOP 1 @TMP=TDR.TAXI,@GOV_NUMBER=ccc.GOV_NUMBER,@GOV_NUMBER_Short=ccc.GOV_NUMBER_Short FROM TAXI_DR TDR 
				LEFT JOIN Cars ccc ON TDR.Car=ccc.UniKey
				WHERE  TDR.Driver=@Driver AND (TDR.DATEIN<=GETDATE() AND (TDR.DATEOUT>=GETDATE() OR TDR.DATEOUT IS NULL));			
			exec [dbo].[P_Ultra] @R=3, @OrderId=@UltraKey, @StatusId=@TMP, @Command=3, @Price=@Price, @ToCarMin=@TIMETOCLIENT,
				@VarChar1=@GOV_NUMBER, @VarChar2=@GOV_NUMBER_Short, @UltraExchange=@UltraExchange,
				@ValueInt2=@Driver, @ValueInt1=@OldDRIVER;
			end;

		--RAISERROR (N'This is message %s %d.', 10,1); -- Second argument.
------------------------------------------------		
		--  
		if (@ZakazPlace=100)
			begin
			-- 
			exec [P_FINE] @R=6,@BASE=@UniKey;
			--  VIP 
			if (@VIP IS NOT NULL) AND (@isError=0) AND (@isEnabledDiscountByVIP=1) 
				begin
				EXEC [P_DISCOUNTS_CUMULATIVE_ADD_VIP] @OrderKey=@UniKey,
					@VIP=@VIP,@DateIn=@DateIn,@isDiscount=@isDiscount,
					@Driver=@Driver, @isClearing=@isClearing;
				end;
------------------------------------------------
			--         
			if (@PhoneKey IS NOT NULL) AND (@isError=0) AND (@isEnabledDiscountByPhone=1)
				begin
				EXEC [P_DISCOUNTS_CUMULATIVE_ADD_PHONE] @OrderKey=@UniKey,
					@PhoneKey=@PhoneKey,@DateIn=@DateIn,@isDiscount=@isDiscount,
					@Driver=@Driver, @isClearing=@isClearing;
				end;
			--     
			if (@PhoneKey IS NOT NULL) AND @isDiscount=1
				begin
				IF EXISTS(SELECT 1 FROM PiramideClientsPoints WHERE OrderKey=@UniKey)
					begin
					if @isError=0 UPDATE PiramideClientsPoints SET DbKr=2 WHERE OrderKey=@UniKey;
						ELSE
						UPDATE PiramideClientsPoints SET DbKr=3 WHERE OrderKey=@UniKey;
					-- 
					EXEC P_PIRAMIDE_CLIENTS_POINTS_UPDATE @DiscountSourceType=6,@AbstractKey=@PhoneKey;
					END;
				end;			
			--          - VIP  
			if @isDiscount=1 AND @isError=0 AND ((@VIP IS NOT NULL) OR (@PhoneKey IS NOT NULL))
				begin
				SET @DiscountsCumulativeActionsCount=NULL;
				SELECT @DiscountsCumulativeActionsCount=COUNT(*) FROM DiscountOrders DO with(nolock) 
					LEFT JOIN DiscountsCumulativeActions DA ON DA.DiscountsCumulativeKey=DO.SourceDetailKey
					WHERE DO.SourceType IN (SELECT UniKey FROM DiscountSourceType DST WHERE DST.isCumulative=1)
						AND DO.OrderKey=@UniKey AND DA.ActionMoment=1;
				IF ISNULL(@DiscountsCumulativeActionsCount,0)>0
					begin
					-- 
					DECLARE DiscountActionCumulativeCursor CURSOR FAST_FORWARD FOR
					SELECT DO.SourceType,DO.SourceDetailKey  FROM DiscountOrders DO with(nolock) 
						LEFT JOIN DiscountsCumulativeActions DA ON DA.DiscountsCumulativeKey=DO.SourceDetailKey
						WHERE DO.SourceType IN (SELECT UniKey FROM DiscountSourceType DST WHERE DST.isCumulative=1)
						AND DO.OrderKey=@UniKey AND DA.ActionMoment=1  GROUP BY DO.SourceType,DO.SourceDetailKey
						FOR READ ONLY;
					OPEN DiscountActionCumulativeCursor
					FETCH NEXT FROM DiscountActionCumulativeCursor INTO @TMP,@TMP2
					WHILE @@FETCH_STATUS = 0
						BEGIN
						EXEC [P_DISCOUNTS_CUMULATIVE_ACTIONS_PROCESS] @OrderKey=@UniKey,
							@DiscountsCumulativeKey=@TMP2,@ActionMoment=1,@DiscountSourceType=@TMP;
						--RaISERROR 99999 '====';
						FETCH NEXT FROM DiscountActionCumulativeCursor INTO @TMP,@TMP2
						END;
					CLOSE DiscountActionCumulativeCursor;
					DEALLOCATE DiscountActionCumulativeCursor;					
					end;
				end;
		-- 
		SELECT @Card=COL.[Card],@TMP=UniKey FROM CardOrderLink COL WHERE COL.[Order]=@UniKey;
		if (@Card IS NOT NULL) 
			begin
			--    
			if EXISTS(SELECT * FROM Cards WHERE UniKey=@Card AND isHasCash=1)
				begin
				if(@isError=0)	UPDATE CardOrderLink SET [sum]=@Price WHERE UniKey=@TMP;
					else UPDATE CardOrderLink SET [sum]=0 WHERE UniKey=@TMP;
				--  
				UPDATE Cards SET ActiveBalance=isnull([dbo].[GetCardBalance](UniKey),0) WHERE UniKey=@Card;
				end;
			end;
		-- 
		if (@isClearing=1)
			begin
			SET @CurContract=NULL;
			SELECT @CurContract=[Contract] FROM ZakazToContract WHERE Zakaz=@UniKey;
			-- 
			if (@CurContract IS NOT NULL) 
				begin
				--     
				UPDATE  ZakazToContract SET ClearingPrice=dbo.GetClearingPrice(@CurContract,@Price) WHERE [Contract]=@CurContract AND Zakaz=@UniKey;
				--exec [P_PackCodes] @R=12,@UniKey= ,@Contract=@CurContract, @Zakaz=@UniKey;
				/*      */
				exec P_Contracts @R=9,@UniKey=@CurContract;
				end;
			end;
		--  ,    
		IF (@isUseExchangeOrg=1 AND @DRIVER IS NOT NULL AND @isError=0) 
			begin
			SELECT @LPExchangeRelationsKey=ATPKey FROM Drivers WITH(nolock) WHERE UNIKEY=@Driver;
--print '=======  '+CAST(isnull(@LPExchangeRelationsKey,0) as varchar(16))+'  '+CAST(isnull(@Driver,0) as varchar(16));			
			if (@LPExchangeRelationsKey IS NOT NULL) AND (@LegalPerson!=@LPExchangeRelationsKey)
				begin
				SELECT @DateBegin=DateBegin FROM BASE WITH(nolock) WHERE UNIKEY=@UniKey;
				if @isPredv=1 AND @DateBegin IS NULL
					begin
					SELECT @DateBegin=PREDV_DATETIME FROM BASE WITH(nolock) WHERE UNIKEY=@UniKey;
					end;
				if @DateBegin IS NULL SET @DateBegin=@DateIn;
				SET @LPExchangeRelationsCommission=[dbo].[GetLPExchangeRelationsCommission](@LegalPerson,@LPExchangeRelationsKey, @DateBegin,@Price);
				if (@LPExchangeRelationsCommission=0) SET @LPExchangeRelationsKey=NULL; 
				--  
				--exec [dbo].[P_Contracts] @R=9, 
				end;
--print '=======  '+CAST(isnull(@DateBegin,0) as varchar(16))+'  '+CAST(isnull(@LPExchangeRelationsCommission,0) as varchar(16));			
			end;
			
		--               
		UPDATE BASE SET Debt=[dbo].[GetSUMDolgByZakaz](@UniKey),
			LPExchangeRelationsKey=@LPExchangeRelationsKey,
			LPExchangeRelationsCommission=@LPExchangeRelationsCommission WHERE UNIKEY=@UniKey;
		IF (@DRIVER IS NOT NULL) 
			begin
				--        -       
				if (@DateIn IS NOT NULL)
				begin
					if (MONTH(@DateIn)!=MONTH(GETDATE()))
					begin
					EXEC [dbo].[P_BalanceSheet] @R=3,@UniKey=@Driver,@DateBegin=@DateIn;
					--   
					SET @TMP=NULL;
					SELECT TOP 1 @TMP=DriverParent from PiramideDrivers PD WHERE PD.DriverChild=@Driver;
					if (@TMP IS NOT NULL) EXEC [dbo].[P_BalanceSheet] @R=3,@UniKey=@TMP,@DateBegin=@DateIn;
					end;
				end;
				--  
				EXEC P_Drivers_Actions @R=51, @Driver=@DRIVER;		
			end;
		end;--  
		
	--    
	if (@ZakazPlace!=@OldZakazPlace)
		begin
			SELECT @ZAKAZ_PLACE_ACTIONS_COUNT=COUNT(*) FROM ZAKAZ_PLACE_ACTIONS Z WHERE Z.ZAKAZ_PLACE=@ZakazPlace;
			if(ISNULL(@ZAKAZ_PLACE_ACTIONS_COUNT,0)>0)			
				EXEC [dbo].[P_ZAKAZ_PLACE_ACTIONS_EXEC]	@OrderKey=@UniKey,@Zakaz_Place=@ZakazPlace, @DriverKey=@Driver, @Old_Zakaz_Place=@OldZakazPlace;
		end;
	end;
end;