ALTER PROCEDURE [dbo].[P_Rates](@R int=1,@UniKey int=NULL OUTPUT,
@TimeBegin	datetime=NULL,@TimeEnd	datetime=NULL,@TimeEnabled	bit=NULL,@base_price	money=NULL,
@HourPrice	money	=NULL,@MinHourPrice	money	=NULL,@OneKmHourPrice	money	=NULL,
@ZaezdPrice	money	=NULL,@BigZaezdPrice	money	=NULL,@MaxKm	int	=NULL,
@DefaultPrice	money	=NULL,@MaxDiscountPercent	int	=NULL,@isCreateComplexTrackAuto	bit	=NULL,
@hourpayDef	bit	=NULL,@isKmEnabledDef	bit	=NULL,@HourPayType	int	=NULL,@isComplexEnabled	bit	=NULL,
@isClearing	bit	=NULL, @ZAKAZ_TYPE int=NULL,@RateName varchar(32)=NULL, @isEnabled bit=0,
@taxi_taksa money=NULL,@TaksaType int=NULL, @taxi_calc money=NULL, @taxi_percent float=NULL,
@isAutoStartGPS	bit=NULL,@GPSLimitSpeedTo	int=NULL,@GPSLimitTimeTo	int=NULL,
@GPSLimitSpeedFrom	int=NULL,@GPSLimitTimeFrom	int=NULL,@StopPrice	money=NULL,
@GPSNoSatTime	int	=NULL, @OtherService int=null, @KmIncluded float=0, @isAddMinPrice bit=0,
@TIMETOCLIENT int=0, @PriceRoundType int=0, @TaximeterStartZakazPlaceBegin int=null,
@isDiscountZeroPrice bit=0, @base_sum_add money=0, @LPSrc int=null, @Pos int=1, @PriceLanding money=0,
@isTaximeter bit=0, @isCheckGPSExists bit=1, @ZakazExitType int=null, @JMinPrice money=0,
@isEnterClientCard bit=0, @OrderPlaceEnterKmBegin int=null,
@isShowDiscount	bit=1,
@isShowClientCard	bit=1,
@isPredvWaitConfirm bit=0,
@PredvWaitConfirm int=60,
@isTaximeterStartGPXCalcType int=3,
@ClientRadiusTaximeterStart int=0,
@isPredvTimerSetActive bit=0,
@RecalcInterCity bit=0,
@isDisableTaximeterByPrice	bit=0,
@PriceRoundMethod	int=0,
@isClearingShowPrice bit=1, @isSetGeoTo bit=1,
@isWEB	bit=1,
@PriceRoundValue	int=0,
@MinutesIncluded	int=0,
@UserKey int=null,
@TaximeterMinPrice money=0,
@isInterCity bit=0,
@isControlOrderAddressTo bit=0,
@isUseBankCardPayment	bit=0,
@isBankCardPaymentFiscalization bit=0,
@WEBChangePriceOrderState	int=null,
@WEBChangePriceStep	money=0,
@isShowDistanceNewOrder bit=0,
@TaximeterMinPriceShow		bit=0,	-- ,     
@isManualEnterPriceDriver	bit=0,	--     
@isAddressEditableByDriver	bit=0,	--    ()  . 
@isAddPreCalculatedPrice	bit=0,	--     
@isShowPreCalcRoute			bit=0,	--     
@BankCardPaymentDescription	varchar(128)=null,
@RateNameWEB	varchar(64)=null,
@RateWEBComments	varchar(4000)=null,
@SelectOrder varchar(2000)=NULL OUTPUT)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <14.11.2011>
-- Update date: <05.04.2017>
-- Description:	<     >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON
DECLARE @old_usertype INT,@old_username varchar(32),@Q varchar(4000),@PhoneTmp varchar(20), 
	@Driver int, @Count int, @MessageText varchar(256),@UserGroupKey int=null;
	if @R=1 /**/
		begin
		if (@UserKey IS NOT NULL)
			begin
			SELECT @UserGroupKey=UserGroupKey FROM USERS WHERE UniKey=@UserKey;
			end;		
		SET @Q='Select rrr.*,UUU.FIO,CAST(CAST(rrr.TimeBegin as Time) as varchar(5)) as TimeBeginStr, CAST(CAST(rrr.TimeEnd as Time) as varchar(5)) as TimeEndStr,
			(SELECT Count(ROSL.OtherService) FROM Rate_OtherServices_Link ROSL WHERE ROSL.Rate=rrr.UniKey) as OtherServiceCount, U2.FIO as UserUpdateFIO, UUU.FIO as UserCreateFIO FROM Rates rrr
			LEFT JOIN USERS UUU ON UUU.UniKey=rrr.UserCreate LEFT JOIN USERS U2 ON U2.UniKey=rrr.UserUpdate';
		if (@LPSrc IS NOT NULL) 
			begin
			SET @Q=@Q+' cross apply(SELECT POS FROM LPSrcRateLink WHERE LPSrc='+CAST(@LPSrc as varchar(12))+' AND rrr.UniKey=Rate)  Link ORDER BY Link.Pos ASC';
			end
			ELSE 
			begin
			--  ,       
			SET @Q=@Q+'  WHERE 1=1';
			if(@UserGroupKey IS NOT NULL) 
				SET @Q=@Q+' AND (rrr.UniKey IN (SELECT LPSrc.UniKey FROM LPSrc INNER JOIN UsersGroupsLegalPersonLink UGLPL ON UGLPL.UserGroupKey='+CAST(@UserGroupKey as varchar(16))+') OR UserCreate IN (SELECT UniKey FROM USERS WHERE UserGroupKey='+CAST(@UserGroupKey as varchar(16))+'))';
			if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY rrr.isClearing';
			end;
--		RaISERROR 99999 @Q;
		Exec (@Q);
		return;
		end;
	if @R=2 /*  */
		begin
		INSERT INTO Rates (RateName,isEnabled,UserCreate) VALUES(@RateName,@isEnabled,@UserKey);
		SET @UniKey=SCOPE_IDENTITY();
		UPDATE TablesLastUpdate SET TLURates=GETDATE();
		return;
		end;
	if @R=3 /* */
		begin
		if EXISTS(SELECT 1 FROM Rates WHERE UniKey!=@UniKey AND RateName LIKE @RateName)
			SET @RateName=@RateName+'1';
		UPDATE Rates SET RateName=@RateName,isEnabled=@isEnabled,
			TimeBegin=@TimeBegin,TimeEnd=@TimeEnd,TimeEnabled=@TimeEnabled,base_price=@base_price,
			HourPrice=@HourPrice,MinHourPrice=@MinHourPrice,OneKmHourPrice=@OneKmHourPrice,
			ZaezdPrice=@ZaezdPrice,BigZaezdPrice=@BigZaezdPrice,MaxKm=@MaxKm,
			DefaultPrice=@DefaultPrice,MaxDiscountPercent=@MaxDiscountPercent,isCreateComplexTrackAuto=@isCreateComplexTrackAuto,
			hourpayDef=@hourpayDef,isKmEnabledDef=@isKmEnabledDef,HourPayType=@HourPayType,isComplexEnabled=@isComplexEnabled,
			isClearing=@isClearing, ZAKAZ_TYPE=@ZAKAZ_TYPE,
			taxi_taksa=@taxi_taksa,TaksaType=@TaksaType, taxi_calc=@taxi_calc, taxi_percent =@taxi_percent,
			isAutoStartGPS=@isAutoStartGPS,GPSLimitSpeedTo=@GPSLimitSpeedTo,GPSLimitTimeTo=@GPSLimitTimeTo,
			GPSLimitSpeedFrom=@GPSLimitSpeedFrom,GPSLimitTimeFrom=@GPSLimitTimeFrom,StopPrice=@StopPrice,
			GPSNoSatTime=@GPSNoSatTime, isAddMinPrice=@isAddMinPrice, KmIncluded=@KmIncluded,
			TIMETOCLIENT=@TIMETOCLIENT, PriceRoundType=@PriceRoundType, TaximeterStartZakazPlaceBegin=@TaximeterStartZakazPlaceBegin,
			isDiscountZeroPrice=@isDiscountZeroPrice, base_sum_add=@base_sum_add, PriceLanding=@PriceLanding,
			isTaximeter=@isTaximeter,isCheckGPSExists=@isCheckGPSExists, JMinPrice=@JMinPrice,
			isEnterClientCard=@isEnterClientCard, OrderPlaceEnterKmBegin=@OrderPlaceEnterKmBegin,
			isShowDiscount=@isShowDiscount,isShowClientCard=@isShowClientCard,
			isPredvWaitConfirm=@isPredvWaitConfirm, PredvWaitConfirm=@PredvWaitConfirm,
			isTaximeterStartGPXCalcType=@isTaximeterStartGPXCalcType,
			ClientRadiusTaximeterStart=@ClientRadiusTaximeterStart,isPredvTimerSetActive=@isPredvTimerSetActive,
			RecalcInterCity=@RecalcInterCity, isDisableTaximeterByPrice=@isDisableTaximeterByPrice,
			PriceRoundMethod=@PriceRoundMethod, isClearingShowPrice=@isClearingShowPrice, isSetGeoTo=@isSetGeoTo,
			isWEB=@isWEB,RateNameWEB=@RateNameWEB,RateWEBComments=@RateWEBComments,
			PriceRoundValue=@PriceRoundValue,MinutesIncluded=@MinutesIncluded, TaximeterMinPrice=@TaximeterMinPrice,
			isInterCity=@isInterCity,isControlOrderAddressTo=@isControlOrderAddressTo,UserUpdate=@UserKey,DateUpdate=GETDATE(),
			isUseBankCardPayment=@isUseBankCardPayment,BankCardPaymentDescription=@BankCardPaymentDescription,
			isBankCardPaymentFiscalization=@isBankCardPaymentFiscalization,WEBChangePriceOrderState=@WEBChangePriceOrderState,
			WEBChangePriceStep=@WEBChangePriceStep, isShowDistanceNewOrder=@isShowDistanceNewOrder,
			TaximeterMinPriceShow=@TaximeterMinPriceShow,isManualEnterPriceDriver=@isManualEnterPriceDriver,
			isAddressEditableByDriver=@isAddressEditableByDriver, isAddPreCalculatedPrice=@isAddPreCalculatedPrice,
			isShowPreCalcRoute=@isShowPreCalcRoute
			WHERE UniKey=@UniKey;
		UPDATE TablesLastUpdate SET TLURates=GETDATE();
		return;
		end;
	if @R=4 /* */
		begin
		SET @SelectOrder=NULL;
		if EXISTS(SELECT UniKey FROM BASE WHERE Rate=@UniKey)
			begin
			SELECT TOP 1 @MessageText=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_USE_AT' AND LngKey IN (SELECT TOP 1 LngMain FROM PROPERTIES);
			SET @SelectOrder=@MessageText;
			SELECT TOP 1 @MessageText=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_ORDERS' AND LngKey IN (SELECT TOP 1 LngMain FROM PROPERTIES);
			SET @SelectOrder=@SelectOrder+' '+@MessageText;
			end;
		if EXISTS(SELECT UniKey FROM TAKSA WHERE Rate=@UniKey)
			begin
			SET @SelectOrder=isnull(@SelectOrder,'');	--'  ,       .';
			SELECT TOP 1 @MessageText=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_USE_IN_THE_RATES_DRIVERS' AND LngKey IN (SELECT TOP 1 LngMain FROM PROPERTIES);
			SET @SelectOrder=@SelectOrder+ @MessageText; 
			end;
		if (@SelectOrder IS NULL)
			begin
			--  
			UPDATE [Contracts] SET RateDefault=NULL WHERE RateDefault=@UniKey;
			DELETE FROM  Rate_CarType_Link WHERE RateKey=@UniKey;
			DELETE FROM Rates WHERE UniKey=@UniKey;
			UPDATE TablesLastUpdate SET TLURates=GETDATE();
			end;
		return;
		end;
	if @R=5 /*  */
		begin
		SELECT @taxi_taksa=taxi_taksa,@TaksaType=TaksaType, @taxi_calc=taxi_calc, @taxi_percent=taxi_percent
			FROM Rates WHERE UniKey=@UniKey;
		SET @Count=0;
		IF @TaksaType IS NULL 
			begin
			SET @UniKey=0;
			return;
			end;
		DECLARE DriverCursor CURSOR FAST_FORWARD FOR
			SELECT UniKey FROM Drivers WHERE v_state=0 
			FOR READ ONLY;
		OPEN DriverCursor
		FETCH NEXT FROM DriverCursor INTO @Driver;
			WHILE @@FETCH_STATUS = 0
			BEGIN
			if NOT EXISTS(SELECT UniKey FROM TAKSA TTT WHERE Driver=@Driver AND  (TTT.DATEOUT IS NULL OR TTT.DATEOUT>GETDATE()) AND TTT.rate=@UniKey)
				begin
				INSERT INTO TAKSA (DRIVER,DATEIN,DATEOUT,taxi_percent,taxi_taksa,TaksaType,
					taxi_calc,Rate,UserCreate) VALUES (@Driver, GETDATE(),NULL,@taxi_percent,@taxi_taksa,@TaksaType,
					@taxi_calc, @UniKey,@UserKey);
				SET @Count=@Count+1;
				end;
			FETCH NEXT FROM DriverCursor  INTO @Driver;
			END 
		CLOSE DriverCursor;
		DEALLOCATE DriverCursor;		
		SET @UniKey=@Count;
		return;
		end;
	if @R=6 /* .   */
		begin
		SELECT sss.*, MM.MeasureFullName,MM.MeasureName FROM OtherServices sss LEFT JOIN Measure MM ON sss.measure=MM.UniKey 
			 AND MM.Lng=(SELECT TOP 1 LngMain FROM PROPERTIES)
			WHERE sss.UniKey IN (SELECT OtherService FROM Rate_OtherServices_Link WHERE Rate=@UniKey);
		return;
		end;
	if @R=7 /* .   */
		begin
		INSERT INTO Rate_OtherServices_Link (Rate,OtherService) VALUES (@UniKey,@OtherService);
		return;
		end;
	if @R=8 /* .   */
		begin
		DELETE FROM Rate_OtherServices_Link WHERE Rate=@UniKey AND OtherService=@OtherService;
		return;
		end;
	if @R=9 /*    */
		begin
		SELECT @Count=COUNT(UniKey) FROM TAKSA WHERE Rate=@UniKey AND DATEOUT IS NULL;
		UPDATE TAKSA SET DATEOUT=GETDATE() WHERE Rate=@UniKey AND DATEOUT IS NULL;
		SET @UniKey=@Count;
		return;
		end;
	--     
	if @R=10
		begin
		SELECT Pos,Rates.RateName,Rates.UniKey, Rates.isEnabled 
			FROM LPSrcRateLink LEFT JOIN Rates 
			ON LPSrcRateLink.Rate=Rates.UniKey WHERE LPSrcRateLink.LPSrc=@LPSrc ORDER By Pos;
		end;			
		
	--     
	if @R=11
		begin
		if EXISTS (SELECT * FROM LPSrcRateLink WHERE Rate=@UniKey AND LPSrc=@LPSrc)
			UPDATE LPSrcRateLink SET Pos=@Pos WHERE Rate=@UniKey AND LPSrc=@LPSrc;
			ELSE
			INSERT INTO LPSrcRateLink (Rate,LPSrc,Pos) VALUES (@UniKey,@LPSrc,@Pos);
		return;
		end;	
	--     
	if @R=12
		begin
		DELETE FROM LPSrcRateLink WHERE Rate=@UniKey AND LPSrc=@LPSrc;
		return;
		end;			
		
	--       
	if @R=13
		begin
		SELECT RZEL.*,ZET.ZakazExitName FROM Rate_ZakazExitType_Link RZEL
			LEFT JOIN ZakazExitType ZET ON ZET.UniKey=RZEL.ZakazExitType
			WHERE RZEL.Rate=@UniKey ORDER By RZEL.Pos, ZET.Pos;
		return;
		end;					
	--       
	if @R=14
		begin
		if EXISTS (SELECT * FROM Rate_ZakazExitType_Link WHERE Rate=@UniKey AND ZakazExitType=@ZakazExitType)
			UPDATE Rate_ZakazExitType_Link SET Pos=@Pos WHERE Rate=@UniKey AND ZakazExitType=@ZakazExitType;
			ELSE
			INSERT INTO Rate_ZakazExitType_Link (Rate,ZakazExitType,Pos) VALUES (@UniKey,@ZakazExitType,@Pos);
		return;
		end;	
	--       
	if @R=15
		begin
		DELETE FROM Rate_ZakazExitType_Link WHERE Rate=@UniKey AND ZakazExitType=@ZakazExitType;
		return;
		end;			
	--        
	if @R=16
		begin
		SELECT RZEL.*,ZET.ZakazExitName FROM Rate_ZakazExitType_Link RZEL
			LEFT JOIN ZakazExitType ZET ON ZET.UniKey=RZEL.ZakazExitType
			ORDER By RZEL.Pos, ZET.Pos;
		return;
		end;					
END
