ALTER PROCEDURE [dbo].[P_GPX_PRE_ORDER](@R int=1,
@OrderKey	int=NULL,	-- 
@Length		float=0,	-- 
@Duration	float=0,	--  
@precision	int=1,		--
@Geometry	text=NULL	--   (. Google Encoded Polyline Algorithm Format)
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <23.02.2017>
-- Update date: <21.03.2017>
-- Description:	<,       >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON
DECLARE @ID int;
	if @R=1 /*       */
		begin
		SELECT G.* FROM GPX_PRE_ORDER G WITH(readpast) 
			LEFT JOIN BASE B ON G.OrderKey=B.UNIKEY 
			WHERE B.ZAKAZPLACE!=100;
		return;
		end;
	if @R=2 /* */
		begin
		IF EXISTS(SELECT 1 FROM GPX_PRE_ORDER WHERE OrderKey=@OrderKey)
			BEGIN
			UPDATE GPX_PRE_ORDER SET [Geometry]=@Geometry,[Length]=@Length,Duration=@Duration,[precision]=@precision
				WHERE OrderKey=@OrderKey;
			END
			ELSE
			BEGIN
			INSERT INTO GPX_PRE_ORDER (OrderKey,[Geometry],[Length],Duration,[precision])
				VALUES(@OrderKey,@Geometry,@Length,@Duration,@precision);
			END;
		UPDATE TablesLastUpdate SET TLU_GPX_PRE_ORDER=GETDATE();
		return;
		end;
	if @R=4 /*    */
		begin
		DELETE FROM GPX_PRE_ORDER WHERE OrderKey=@OrderKey;
		return;
		end;
	if @R=5 /*   WEB */
		begin
		SELECT @ID=Zakaz FROM WEB with(readpast) WHERE UniKey=@OrderKey;
		IF @ID IS NULL return;		
		IF EXISTS(SELECT 1 FROM GPX_PRE_ORDER WHERE OrderKey=@ID)
			BEGIN
			UPDATE GPX_PRE_ORDER SET [Geometry]=@Geometry,[Length]=@Length,Duration=@Duration,[precision]=@precision
				WHERE OrderKey=@ID;
			END
			ELSE
			BEGIN
			INSERT INTO GPX_PRE_ORDER (OrderKey,[Geometry],[Length],Duration,[precision])
				VALUES(@ID,@Geometry,@Length,@Duration,@precision);
			END;
		UPDATE TablesLastUpdate SET TLU_GPX_PRE_ORDER=GETDATE();
		return;
		end;
END
