SET NUMERIC_ROUNDABORT OFF
GO
SET ANSI_PADDING, ANSI_WARNINGS, CONCAT_NULL_YIELDS_NULL, ARITHABORT, QUOTED_IDENTIFIER, ANSI_NULLS ON
GO
SET XACT_ABORT ON
GO
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
GO
PRINT N'Dropping constraints from [dbo].[DeviceState]'
GO
ALTER TABLE [dbo].[DeviceState] DROP CONSTRAINT [DF_DeviceState_SMSMask]
GO
PRINT N'Altering [dbo].[DeviceState]'
GO
ALTER TABLE [dbo].[DeviceState] ALTER COLUMN [SMSMask] [varchar] (4000) COLLATE SQL_Latin1_General_CP1251_CI_AS NOT NULL
GO
PRINT N'Adding constraints to [dbo].[DeviceState]'
GO
ALTER TABLE [dbo].[DeviceState] ADD CONSTRAINT [DF_DeviceState_SMSMask] DEFAULT ('') FOR [SMSMask]
GO
